# Class AttributeChangeNotificationFilter

java.lang.Object
javax.management.AttributeChangeNotificationFilter

All Implemented Interfaces:
  `Serializable, NotificationFilter`

public class AttributeChangeNotificationFilter extends Object implements NotificationFilter
This class implements of the `NotificationFilter` interface for the `attribute change notification`. The filtering is performed on the name of the observed attribute.

It manages a list of enabled attribute names. A method allows users to enable/disable as many attribute names as required.

Since:
  1.5
See Also:
  - Serialized Form

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `AttributeChangeNotificationFilter()`
  Constructs an `AttributeChangeNotificationFilter`.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `void`
  `disableAllAttributes()`
  Disables all the attribute names.
  `void`
  `disableAttribute(String name)`
  Disables all the attribute change notifications the attribute name of which equals the specified attribute name to be sent to the listener.
  `void`
  `enableAttribute(String name)`
  Enables all the attribute change notifications the attribute name of which equals the specified name to be sent to the listener.
  `Vector<String>`
  `getEnabledAttributes()`
  Gets all the enabled attribute names for this filter.
  `boolean`
  `isNotificationEnabled(Notification notification)`
  Invoked before sending the specified notification to the listener.

  ### Methods declared in class Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`
  Modifier and Type
  Method
  Description
  `protected Object`
  `clone()`
  Creates and returns a copy of this object.
  `boolean`
  `equals(Object obj)`
  Indicates whether some other object is "equal to" this one.
  `protected void`
  `finalize()`
  Deprecated, for removal: This API element is subject to removal in a future version.
  Finalization is deprecated and subject to removal in a future release.
  `final Class<?>`
  `getClass()`
  Returns the runtime class of this `Object`.
  `int`
  `hashCode()`
  Returns a hash code value for this object.
  `final void`
  `notify()`
  Wakes up a single thread that is waiting on this object's monitor.
  `final void`
  `notifyAll()`
  Wakes up all threads that are waiting on this object's monitor.
  `String`
  `toString()`
  Returns a string representation of the object.
  `final void`
  `wait()`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted.
  `final void`
  `wait(long timeoutMillis)`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.
  `final void`
  `wait(long timeoutMillis, int nanos)`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.

- ## Constructor Details

  - ### AttributeChangeNotificationFilter

    public AttributeChangeNotificationFilter()
    Constructs an `AttributeChangeNotificationFilter`.

- ## Method Details

  - ### isNotificationEnabled

    public boolean isNotificationEnabled(Notification notification)
    Invoked before sending the specified notification to the listener.
    This filter compares the attribute name of the specified attribute change notification with each enabled attribute name. If the attribute name equals one of the enabled attribute names, the notification must be sent to the listener and this method returns `true`.
    Specified by:
      `isNotificationEnabled` in interface `NotificationFilter`
    Parameters:
      `notification` - The attribute change notification to be sent.
    Returns:
      `true` if the notification has to be sent to the listener, `false` otherwise.

  - ### enableAttribute

    public void enableAttribute(String name) throws IllegalArgumentException
    Enables all the attribute change notifications the attribute name of which equals the specified name to be sent to the listener.
    If the specified name is already in the list of enabled attribute names, this method has no effect.
    Parameters:
      `name` - The attribute name.
    Throws:
      `IllegalArgumentException` - The attribute name parameter is null.

  - ### disableAttribute

    public void disableAttribute(String name)
    Disables all the attribute change notifications the attribute name of which equals the specified attribute name to be sent to the listener.
    If the specified name is not in the list of enabled attribute names, this method has no effect.
    Parameters:
      `name` - The attribute name.

  - ### disableAllAttributes

    public void disableAllAttributes()
    Disables all the attribute names.

  - ### getEnabledAttributes

    public Vector<String> getEnabledAttributes()
    Gets all the enabled attribute names for this filter.
    Returns:
      The list containing all the enabled attribute names.